#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define PI 3.1415926535

int bgmtable[34][3]={
{0x111040ee, 0x1122b56e, 0x120fce4a}, // 01 17
{0x00000e86, 0x0005ab4e, 0x00e18902}, // 02 00
{0x00e43ae2, 0x00f54ed6, 0x01a57d2a}, // 03 01
{0x0320b836, 0x03292d82, 0x03c89dea}, // 04 03
{0x03cb4fca, 0x03ccf8b6, 0x047b90aa}, // 05 04
{0x047e4056, 0x04818a1a, 0x0590040a}, // 06 05
{0x0592b5ea, 0x059762da, 0x0678148e}, // 07 06
{0x067b6a92, 0x0683d372, 0x07ba4e36}, // 08 07
{0x07bd0096, 0x07c38bf6, 0x0868dca2}, // 09 08
{0x086ba93e, 0x087311ba, 0x097f97f6}, // 10 09
{0x098249d6, 0x09a5708e, 0x0a6d572a}, // 11 10
{0x0a701e7e, 0x0a77adc2, 0x0b2bfee2}, // 12 11
{0x0b2eb0c2, 0x0b55aa62, 0x0c15b856}, // 13 12
{0x0c18956a, 0x0c57d4fa, 0x0cd90472}, // 14 13
{0x0cdbb656, 0x0cfc10b2, 0x0d6eee2e}, // 15 14
{0x01a82ec6, 0x01c31ade, 0x031e069a}, // 16 02
{0x0d71a012, 0x0d81c502, 0x0efd081a}, // 17 15
{0x0effb9b6, 0x0f09294a, 0x110d8f52}, // 18 16
{0x13813dda, 0x138bc5c2, 0x141b5b72}, // 19 21
{0x12128196, 0x12128196, 0x12f3795e}, // 20 18 // roop
{0x12f37a06, 0x12f63f06, 0x134c60b6}, // 21 19
{0x134f1312, 0x1361cf7a, 0x137fc1e2}, // 22 20
{0x141e0dce, 0x142653b6, 0x14e81aca}, // 23 22
{0x14eacd26, 0x14ec862e, 0x1524b87e}, // 24 23
{0x15276ada, 0x1530a6a6, 0x15788306}, // 25 24
{0x157b3562, 0x157f716e, 0x15e42486}, // 26 25
{0x18837212, 0x188828ae, 0x18f3d466}, // 27 32
{0x171d8436, 0x17273dbe, 0x178e9a72}, // 28 29
{0x15e6d6e2, 0x15ec8bca, 0x164a98aa}, // 29 26
{0x18f6b6ba, 0x18fec83a, 0x197ffc3e}, // 30 33
{0x164b9ee6, 0x164fdcde, 0x16ac2a36}, // 31 27
{0x16aeef8e, 0x16b88822, 0x171aa942}, // 32 28
{0x181fb16a, 0x182a7e02, 0x1880a0ae}, // 33 31
{0x179c08c2, 0x17a3dc0a, 0x181cfd56}, // 34 30
};


char bgmfile[34][50]={
"01 z.wav",
"02 dk.wav",
"03 Yzȁ@` Capriccio.wav",
"04 F}WbN.wav",
"05 B̕.wav",
"06 Chƌ̉v.wav",
"07 v@` iE_CA.wav",
"08 uNVeB̐l`t.wav",
"09 l`ٔ.wav",
"10 NgK[`.wav",
"11 @}.wav",
"12 LLˉ`Till WhenH.wav",
"13 dX@` Ancient Temple.wav",
"14 Sׂ̈̃Zvebg.wav",
"15 Hɍ炩An̍`Border of Life.wav",
"16 Demystify Feast.wav",
"17 邪~Ă@` Evening Star.wav",
"18 䉾̍̋S@` Missing Power.wav",
"19 Ė.wav",
"20 z.wav",
"21 .wav",
"22 .wav",
"23 ՎQ.wav",
"24 S.wav",
"25 Intermezzo.wav",
"26 ̂.wav",
"27 X.wav",
"28 .wav",
"29 H.wav",
"30 q.wav",
"31 g.wav",
"32 v.wav",
"33 Ћ@.wav",
"34 ӌ.wav",
}; 

void makeheader(char *header,int datasize){
	int i;
	short s;
	memcpy(header,"RIFF",4);
	i = datasize + 36;
	memcpy(header+4,&i,4);
	memcpy(header+8,"WAVEfmt ",8);
	i = 16;
	memcpy(header+16,&i,4);
	s = 1;
	memcpy(header+20,&s,2);
	s = 2;
	memcpy(header+22,&s,2);
	i = 44100;
	memcpy(header+24,&i,4);
	i = 176400;
	memcpy(header+28,&i,4);
	s = 4;
	memcpy(header+32,&s,2);
	s = 16;
	memcpy(header+34,&s,2);
	memcpy(header+36,"data",4);
	i = datasize;
	memcpy(header+40,&i,4);
	
}

int main(int argc,char *argv[]){
	FILE *datf,*bgmf;
	int i,j,l,k;
	int rep=2;
	int length=0;
	int fade=0;
	int fadep=0;
	int ts=0;
	int te=34;
	char header[44];
	short buf[44100*2];
	int s,e;
	double d;
	
	//bgmtable(JnAJԂn_܂ł̒AI_܂ł̒)Ȃ̂
	//ꂼʒuɊZ
//	for(i=0;i<7;i++){
//		bgmtable[i][1]+=bgmtable[i][0];
//		bgmtable[i][2]+=bgmtable[i][0];
//	}
	
	//argc̃`FbN
	for(i=1;i<argc;i++){
		switch(argv[i][0]){
		case 'f' :
			argv[i]++; fade=atoi(argv[i]); break;
		case 'F' :
			argv[i]++; fade=-atoi(argv[i]); break;
		case 'P' :
		case 'p' :
			argv[i]++; fadep=atoi(argv[i]); break;
		case 'T' :
		case 't' :
			argv[i]++; ts=te=atoi(argv[i]); break;
		default:
			rep=atoi(argv[i]);
		}
	}
	
	if(rep<1 || rep>10){
		printf("repeat must be 1-10\n");
		return 0;
	}
	if(fade<-30 || fade>30){
		printf("fade must be 0-30\n");
		return 0;
	}
	if(fadep<0 || fadep>3){
		printf("fade pattern must be 0-3\n");
		return 0;
	}
	if(ts<0 || te>34){
		printf("track number must be 1-7\n");
		return 0;
	}
		
	
	printf("track=%d-%d , repeat=%d , fade=%d , fade pattern=%d\n",ts,te,rep,fade,fadep);
	if(ts) ts--;
	
	datf=fopen("th075bgm.dat","rb");
	if(datf==NULL){
		printf("th075bgm.dat not found.");
		return 0;
	}
	
	//Jn
	for(i=ts;i<te;i++){
		
		printf("Create %s ...\n",bgmfile[i]);
		bgmf=fopen(bgmfile[i],"wb");
		length=(bgmtable[i][2]-bgmtable[i][0])+(bgmtable[i][2]-bgmtable[i][1])*(rep-1);
		if(fade<0) length+=(-fade)*44100*4;
		makeheader(header,length);
		fwrite(header,1,44,bgmf);
		
		//[v
		for(k=0;k<rep;k++){
			//[
			s=bgmtable[i][1];
			if(k==0) s=bgmtable[i][0];
			
			//I[
			e=bgmtable[i][2];
			if(k==rep-1 && fade>0) e=bgmtable[i][2]-fade*44100*4;
			
			for(j=s;j<e;j+=44100*4){
				if(j+44100*4>e) l=e-j;
				else l=44100*4;
				
				fseek(datf,j,SEEK_SET);
				fread(buf,1,l,datf);
				fwrite(buf,1,l,bgmf);
			}
		}
		
		//tF[hAEg
		if(fade>0){
			//[vI[
			s=bgmtable[i][2]-fade*44100*4;
			e=bgmtable[i][2];
		}
		else if(fade<0){
			//[v[
			s=bgmtable[i][1];
			e=s-fade*44100*4;
		}
		else{
			s=e=0;
		}
			
		for(j=s;j<e;j+=44100*4){
			if(j+44100*4>e) l=e-j;
			else l=44100*4;
			
			fseek(datf,j,SEEK_SET);
			fread(buf,1,l,datf);
			for(k=0;k<l/4;k++){
				switch (fadep) {
				case 0 :
					d=(float)((j-s)/4+k)/(abs(fade)*44100);
					d=pow(0.001,d);
					break;
				case 1 :
					d=1-(float)((j-s)/4+k)/(abs(fade)*44100);
					break;
				case 2 :
					d=(float)((j-s)/4+k)/(abs(fade)*44100);
					d=(pow(0.001,d)+(1-d))/2;
					break;
				case 3 :
					d=(cos(PI*(float)((j-s)/4+k)/(abs(fade)*44100))+1)/2;
					break;
				}
				
				buf[2*k]=(short)(buf[2*k]*d);
				buf[2*k+1]=(short)(buf[2*k+1]*d);
			}
			fwrite(buf,1,l,bgmf);
		}
		
		fclose(bgmf);
	}
	fclose(datf);
	
	return 0;
}


